import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import invariant from 'invariant';


export default ({
    Component
} = {}) => {

    invariant(Component !== undefined, 'Missing Datepicker component.');

    return React.createClass({

        displayName: `${Component.displayName}`,

        mixins: [PureRenderMixin],

        propTypes: {
            onChange: PropTypes.func,
            initialValue: PropTypes.oneOfType([
                PropTypes.instanceOf(Date),
                PropTypes.number
            ])
        },

        getDefaultProps() {
            return {
                onChange: (/* value */) => {},
                initialValue: null
            };
        },

        getInitialState() {
            const { initialValue: value } = this.props;
            return {
                value
            };
        },

        onChange(value) {
            this.setState({ value }, () => this.props.onChange(value));
        },

        render() {
            return (
                <Component
                    { ...this.props }
                    { ...this.state }
                    onChange={ this.onChange }
                    onCollapse={ this.onCollapse }
                    onExpand={ this.onExpand }
                    onSelectedIndexChange={ this.onSelectedIndexChange } />
            );
        }

    });

};
