import React from 'react';
import purebem from 'purebem';
import { mount } from 'enzyme';

import Dropdown from './Dropdown';
import DropdownState from './DropdownState';

import dropdownValueOptionState from './option-value/dropdownValueOptionState';


const TestDropdown = Dropdown({
    block: purebem.of('test-dropdown'),
    displayName: 'TestDropdown'
});

const TestDropdownState = DropdownState({
    Component: TestDropdown
});

test('should change value when clicking option', () => {
    const onChange = jest.fn();
    const options = [
        dropdownValueOptionState({ text: 'A', value: 'a' }),
        dropdownValueOptionState({ text: 'B', value: 'b' }),
        dropdownValueOptionState({ text: 'C', value: 'c' })
    ];

    const dropdown = mount(
        <TestDropdownState
            onChange={ onChange }
            options={ options } />
    );

    dropdown.simulate('click');

    const elements = dropdown.find('TestDropdownValueOption');
    expect(elements.length).toBe(3);

    elements.at(1).simulate('click');

    expect(onChange).toHaveBeenCalledWith('b');
});
