import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import invariant from 'invariant';


export default ({
    Component
} = {}) => {

    invariant(Component !== undefined, 'Missing Dropdown component.');

    return React.createClass({

        displayName: `${Component.displayName}State`,

        mixins: [PureRenderMixin],

        propTypes: {
            onChange: PropTypes.func,
            initialValue: PropTypes.any
        },

        getDefaultProps() {
            return {
                onChange: (/* value */) => {},
                initialValue: ''
            };
        },

        getInitialState() {
            const { initialValue: value } = this.props;
            return {
                value
            };
        },

        componentWillReceiveProps(nextProps) {
            if (nextProps.initialValue !== this.props.initialValue) {
                // needed when the dropdown is used as a navigation menu.
                this.setState({ value: nextProps.initialValue });
            }
        },

        onChange(value) {
            this.setState({ value }, () => this.props.onChange(value));
        },

        render() {
            return (
                <Component
                    { ...this.props }
                    { ...this.state }
                    onChange={ this.onChange } />
            );
        }

    });

};
